require 'reportsmash/control'
if defined? Rails
  if Rails::VERSION::MAJOR.to_i >= 3
    module ReportsMash
      class Railtie < Rails::Railtie

        initializer "reportsmash.start_plugin" do |app|
          ReportsMash::Control.instance.init_plugin(:config => app.config)
        end
      end
    end
  else
    # After version 2.0 of Rails we can access the configuration directly.
    # We need it to add dev mode routes after initialization finished.
    config = nil
    config = Rails.configuration if Rails.respond_to?(:configuration)
    ReportsMash::Control.instance.init_plugin :config => config
  end
else
  ReportsMash::Control.instance.init_plugin
end

