module ReportsMash
  module Engine
    require 'reportsmash/engine/transaction'
    require 'reportsmash/engine/engine'
    require 'reportsmash/engine/thread_state'
    require 'reportsmash/engine/threading'
    require 'reportsmash/engine/worker'
    require 'reportsmash/engine/instrumentation/external'
    require 'reportsmash/engine/instrumentation/memcache/dalli'
    require 'reportsmash/engine/instrumentation/memcache/mem_cache'
    require 'reportsmash/engine/instrumentation/memcache/memcached'
    require 'reportsmash/engine/instrumentation/redis'
    require 'reportsmash/engine/instrumentation/typhoeus'
    require 'thread'

    extend self
    @engine = nil
    @options = {}

    attr_accessor :options

    def engine
      @engine || raise("ReportsMash plugin not initialized!")
    end

    def engine=(new_instance)
      @engine = new_instance 
    end
    alias instance engine

    def boot_from_fork
      engine.boot_from_fork()
    end

    def custom_attr(params)
      @engine.custom_attr(params)
    end

  end
end

