module ReportsMash::Engine::Instrumentation::Memcache
	module Dalli

		if defined?(::Dalli) && defined?(::Dalli::Client)
			::Dalli::Client.class_eval do

	      def reportsmash_mc_get(*args)
	      	start_time = Time.now
	      	rv = orig_get(*args)
	      	ReportsMash::Engine::Instrumentation::External.record_mc_trace("get", (Time.now - start_time)*1000.0)
	        rv
	      end
	      alias :orig_get :get
	      alias :get :reportsmash_mc_get

	      def reportsmash_mc_set(*args)
	      	start_time = Time.now
	      	rv = orig_set(*args)
	      	ReportsMash::Engine::Instrumentation::External.record_mc_trace("set", (Time.now - start_time)*1000.0)
	        rv
	      end
	      alias :orig_set :set
	      alias :set :reportsmash_mc_set   


	      def reportsmash_mc_get_multi(*args)
	      	start_time = Time.now
	      	rv = orig_get_multi(*args)
	      	ReportsMash::Engine::Instrumentation::External.record_mc_trace("get_multi", (Time.now - start_time)*1000.0)
	      	rv
	      end
	      alias :orig_get_multi :get_multi
	      alias :get_multi :reportsmash_mc_get_multi

	    end
	  end

	end
end
