module ReportsMash::Engine::Instrumentation::Memcache
	module Memcached

		if defined?(::Memcached) && Gem::Version.new("1.8.0") <= Gem::Version.new(::Memcached::VERSION)
			::Memcached.class_eval do

	      def reportsmash_mc_single_get(*args)
	      	start_time = Time.now
	      	rv = orig_single_get(*args)
	      	ReportsMash::Engine::Instrumentation::External.record_mc_trace("get", (Time.now - start_time)*1000.0)
	        rv
	      end
	      alias :orig_single_get :single_get
	      alias :single_get :reportsmash_mc_single_get

	      def reportsmash_mc_multi_get(*args)
	      	start_time = Time.now
	      	rv = orig_multi_get(*args)
	      	ReportsMash::Engine::Instrumentation::External.record_mc_trace("get_multi", (Time.now - start_time)*1000.0)
	      	rv
	      end
	      alias :orig_multi_get :multi_get
	      alias :multi_get :reportsmash_mc_multi_get


	      def reportsmash_mc_single_cas(*args)
	      	start_time = Time.now
	      	rv = orig_single_cas(*args)
	      	ReportsMash::Engine::Instrumentation::External.record_mc_trace("set", (Time.now - start_time)*1000.0)
	        rv
	      end
	      alias :orig_single_cas :single_cas
	      alias :single_cas :reportsmash_mc_single_cas

	      def reportsmash_mc_multi_cas(*args)
	      	start_time = Time.now
	      	rv = orig_multi_cas(*args)
	      	ReportsMash::Engine::Instrumentation::External.record_mc_trace("set", (Time.now - start_time)*1000.0)
	        rv
	      end
	      alias :orig_multi_cas :multi_cas
	      alias :multi_cas :reportsmash_mc_multi_cas

	    end
	  end

	end
end