module ReportsMash::Engine::Instrumentation
	module Redis
	
		if defined?(::Redis)
		  ::Redis.class_eval do

	      def reportsmash_redis_get(*args)
	      	start_time = Time.now
	      	rv = orig_get(*args)
	      	ReportsMash::Engine::Instrumentation::External.record_redis_trace("get", (Time.now - start_time)*1000.0)
	        rv
	      end
	      alias :orig_get :get
	      alias :get :reportsmash_redis_get

	      def reportsmash_redis_set(*args)
	      	start_time = Time.now
	      	rv = orig_set(*args)
	      	ReportsMash::Engine::Instrumentation::External.record_redis_trace("set", (Time.now - start_time)*1000.0)
	        rv
	      end
	      alias :orig_set :set
	      alias :set :reportsmash_redis_set
	      
	    end
		end
	end
end
