module ReportsMash::Engine::Instrumentation
	SUPPORTED_VERSION = "0.5.3"
	if defined?(::Typhoeus) && defined?(::Typhoeus::VERSION) && Gem::Version.new(SUPPORTED_VERSION) <= Gem::Version.new(::Typhoeus::VERSION)
	  Typhoeus.before do |request|
	    #start trace
	    start_time = Time.now
			cb = Proc.new do
				duration = (Time.now - start_time)*1000.0
				data = {
					client: "Typhoeus",
					duration: duration,
					response_code: request.response.response_code,
					url: request.url,
					method: request.original_options[:method].to_s.upcase
				}
				ReportsMash::Engine::Instrumentation::External.record_http_trace(data)
			end
			request.on_complete.unshift(cb)
			true
		end
	end
end
