require 'reportsmash/engine'

module ReportsMash::Rack
  # This middleware is used by the agent internally, and is usually injected
  # automatically into the middleware chain. If automatic injection is not
  # working, you may manually use it in your middleware chain instead.
  #
  # @api public
  #
  class Hooks
    def initialize(app, options = {})
      @app = app
    end

    #include TransactionReset

    # method required by Rack interface
    # [status, headers, response]
    def call(env)
      ReportsMash::Engine::ThreadState.clear
      ReportsMash::Engine.engine.transaction_start(env)
      start_time = Time.now
      begin
      	result = @app.call(env)
        stop_time = Time.now
        ReportsMash::Engine.engine.transaction_end(start_time, stop_time, nil, result, env)
      rescue => e
        stop_time = Time.now
        ReportsMash::Engine.engine.transaction_end(start_time, stop_time, e, nil, env)
        raise(e)
      end
      result
    end

  end
end

